<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" label-width="100px">
      <div class="search-z">
        <el-form-item :label="$t('客户编号')" prop="number">
          <el-input v-model.trim="queryParams.number" :placeholder="$t('请输入客户编号')" clearable @keyup.enter.native="handleQuery" @input="queryParams.number = queryParams.number.replace(/\s+/g, '')" />
        </el-form-item>
        <el-form-item :label="$t('客户名称')" prop="name">
          <el-input v-model="queryParams.name" :placeholder="$t('请输入客户名称')" clearable @keyup.enter.native="handleQuery" @blur="trimCustomerName" />
        </el-form-item>
        <el-form-item :label="$t('区号')">
          <el-select filterable v-model="queryParams.areaCode" clearable :placeholder="$t('请选择区号')">
            <el-option v-for="(item, index) in countryList" :key="index" :label="item.nameShort + (isChinese ? item.nameZh : item.nameEn) + ' +' + item.tel" :value="item.tel" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('联系方式')">
          <el-input :placeholder="$t('请输入联系方式')" clearable v-model.trim="queryParams.defaultContactPhone" @input="queryParams.defaultContactPhone = queryParams.defaultContactPhone.replace(/\s+/g, '')"></el-input>
        </el-form-item>
        <el-form-item :label="$t('部门')" v-if="path != '/customer/department-customers'">
          <el-select filterable clearable v-model="queryParams.deptIds" :placeholder="$t('请选择部门')">
            <el-option v-for="item in deptList" :key="item.id" :label="item.name" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('客户经理')" prop="customerService">
          <el-select filterable multiple clearable v-model="queryParams.customerService" :placeholder="$t('请选择客户经理')" size="small" @change="handleQuery">
            <el-option v-for="dict in customerServiceList" :key="dict.id" :label="dict.nickname" :value="dict.id" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('客户来源')" prop="source">
          <el-select filterable multiple clearable v-model="queryParams.source" :placeholder="$t('请选择客户来源')" size="small" @change="handleQuery">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_SOURCE)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('客户类别')" prop="level">
          <dict-selector filterable multiple clearable :type="DICT_TYPE.CUSTOMER_TYPE" v-model="queryParams.type" @change="handleQuery"></dict-selector>
        </el-form-item>
        <el-form-item :label="$t('角色')">
          <dict-selector filterable multiple clearable :type="DICT_TYPE.CUSTOMER_ROLE" v-model="queryParams.role" formatter="number" @change="handleQuery" :placeholder="$t('请选择')"></dict-selector>
        </el-form-item>
        <el-form-item :label="$t('客户状态')" prop="status">
          <el-select filterable multiple clearable v-model="queryParams.status" :placeholder="$t('请选择客户状态')" size="small" @change="handleQuery">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_STATUS)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('国籍')" prop="country">
          <el-select filterable multiple clearable v-model="queryParams.country" :placeholder="$t('请选择')" @change="handleQuery">
            <el-option v-for="dict in countryList" :key="dict.id" :label="isChinese ? dict.nameZh : dict.nameEn" :value="parseInt(dict.id)" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('出货渠道')">
          <dict-selector filterable multiple clearable :type="DICT_TYPE.ECW_CUSTOMER_TRANSPORT_TYPE" v-model="queryParams.transportType" formatter="number" @change="handleQuery"></dict-selector>
        </el-form-item>

        <el-form-item :label="$t('业务国家')" v-show="showSearch">
          <el-select filterable multiple clearable v-model="queryParams.busiCountryIds" :placeholder="$t('请选择')" @change="handleQuery">
            <el-option v-for="dict in countryList" :key="dict.id" :label="isChinese ? dict.nameZh : dict.nameEn" :value="parseInt(dict.id)" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('常用提货网点')" v-show="showSearch">
          <el-select filterable multiple v-model="queryParams.pickupPoints" :placeholder="$t('请选择提货网点')">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.PICKUP_POINTS)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('创建人')" v-show="showSearch">
          <el-select filterable v-model="queryParams.founder">
            <el-option v-for="item in allSimplList" :key="item.id" :label="item.nickname" :value="item.id"> </el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('业绩类型')" v-show="showSearch">
          <el-select filterable clearable v-model="queryParams.isNew">
            <el-option :label="$t('新客户')" :value="true" />
            <el-option :label="$t('老客户')" :value="false" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('年度发货量')" v-show="showSearch">
          <el-input v-model.trim="weightYearly.value" :placeholder="$t('请输入数字')" clearable @keyup.enter.native="handleQuery" @input="weightYearly.value = weightYearly.value.replace(/\s+/g, '')">
            <template slot="prepend">
              <dict-selector :type="DICT_TYPE.CUSTOMER_QUERY_NUMBER_FIELD" defaultable v-model="weightYearly.key" />
            </template>
          </el-input>
        </el-form-item>
        <el-form-item :label="$t('主营商品类别')" v-show="showSearch">
          <el-select filterable @change="handleSelectProductType" multiple v-model="queryParams.productTypes" :placeholder="$t('请选择')">
            <el-option :label="item.titleZh" :value="item.id" v-for="item in productTypeList" :key="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('主营商品名称')" v-show="showSearch">
          <el-select multiple filterable clearable v-model="queryParams.productIds" :placeholder="$t('请选择商品名称')">
            <el-option :label="item.titleZh" :value="parseInt(item.id)" v-for="item in productList" :key="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('主要竞争对手')" v-show="showSearch">
          <el-select multiple filterable clearable v-model="queryParams.competitorIds" :placeholder="$t('请选择竞争对手')" size="small" @change="handleQuery">
            <el-option v-for="item in competitorList" :key="item.id" :label="item.name" :value="item.id"> </el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('年度发货次数')" v-show="showSearch">
          <el-input v-model.trim="numYearly.value" :placeholder="$t('请输入数字')" clearable @keyup.enter.native="handleQuery" @input="numYearly.value = numYearly.value.replace(/\s+/g, '')">
            <template slot="prepend">
              <dict-selector :type="DICT_TYPE.CUSTOMER_QUERY_NUMBER_FIELD" defaultable v-model="numYearly.key" />
            </template>
          </el-input>
        </el-form-item>
        <el-form-item :label="$t('推介人')" v-show="showSearch">
          <el-select filterable clearable remote :remote-method="remoteMethod" v-model="queryParams.promoter" :placeholder="$t('请输入推介人')" filterable>
            <el-option v-for="item in customerSelectFn" :key="item.id" :label="item.name" :value="item.id"> </el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('获取方式')" v-show="showSearch">
          <el-select filterable v-model="queryParams.getMethods" multiple :placeholder="$t('请选择')">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_GET_METHOD)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('创建入口')" v-show="showSearch">
          <el-select filterable v-model="queryParams.createFroms" multiple :placeholder="$t('请选择')">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_FROM)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('结算方式')" v-show="showSearch">
          <el-select filterable v-model="queryParams.balances" multiple :placeholder="$t('请选择结算方式')">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_BALANCE)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('入仓确认')" v-show="showSearch">
          <el-select clearable v-model="queryParams.arrivalConfirm">
            <el-option :label="$t('是')" :value="1" />
            <el-option :label="$t('否')" :value="0" />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('会员电话')" prop="department" label-width="100px" v-show="showSearch">
          <el-input :placeholder="$t('请输入会员电话')" class="w-200" clearable v-model.trim="queryParams.memberMobile" @input="queryParams.memberMobile = queryParams.memberMobile.replace(/\s+/g, '')">
            <template slot="prepend">
              <area-code-selector v-model="queryParams.memberAreaCode" class="w-50" />
            </template>
          </el-input>
        </el-form-item>
        <el-form-item :label="$t('会员编号')" prop="number" v-show="showSearch">
          <el-input v-model.trim="queryParams.memberCode" :placeholder="$t('请输入会员编号')" clearable @keyup.enter.native="handleQuery" />
        </el-form-item>
        <el-form-item :label="$t('控货无收货人')" v-show="showSearch" label-width="100px">
          <div style="width: 194px">
            <el-switch v-model="queryParams.noConsignee" />
          </div>
        </el-form-item>
        <el-form-item :label="$t('默认付款')" v-show="showSearch" label-width="70px">
          <div style="width: 194px">
            <el-switch v-model="queryParams.defaultPay" />
          </div>
        </el-form-item>
        <el-form-item :label="$t('是否显示提单价格')" v-show="showSearch" label-width="130px">
          <div style="width: 194px">
            <el-switch v-model="queryParams.isShowTidanPrice" />
          </div>
        </el-form-item>
      </div>
      <div class="search-time">
        <el-form-item :label="$t('入公海时间')" v-show="showSearch">
          <el-date-picker type="datetimerange" clearable v-model="enterOpenSeaTime" value-format="yyyy-MM-dd HH:mm:ss" range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
        </el-form-item>
        <el-form-item :label="$t('归属时间')" v-show="showSearch">
          <el-date-picker type="datetimerange" clearable v-model="customerServiceConfirmedTime" value-format="yyyy-MM-dd HH:mm:ss" range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
        </el-form-item>
        <el-form-item :label="$t('首次成交时间')" v-show="showSearch">
          <el-date-picker type="datetimerange" clearable v-model="firstDealTime" value-format="yyyy-MM-dd HH:mm:ss" range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
        </el-form-item>

        <el-form-item :label="$t('创建时间')">
          <el-date-picker type="datetimerange" clearable v-model="createTime" value-format="yyyy-MM-dd HH:mm:ss" range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
        </el-form-item>
        <el-form-item style="padding-left: 20px">
          <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{ $t("搜索") }}</el-button>
          <el-button icon="el-icon-refresh" @click="resetQuery">{{ $t("重置") }}</el-button>
        </el-form-item>
      </div>
    </el-form>

    <!-- 操作工具栏 -->
    <div v-if="path === '/customer/customer'" style="color: red; margin-bottom: 5px">注意：创建的客户需接收</div>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button v-if="path === '/customer/potential'" type="primary" plain icon="el-icon-plus" size="mini" @click="handleAddPotential">{{ $t("新增潜在客户") }}</el-button>
        <el-button v-else type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="[selectAuthorityFn('ecw:customer:create')]">{{ $t("新增") }} </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button :disabled="selectCustomerList.length === 0" type="primary" size="mini" @click="transferShow = true" v-hasPermi="[selectAuthorityFn('ecw:customer:batch-transfer')]">{{ $t("批量移交") }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading" v-hasPermi="[selectAuthorityFn('ecw:customer:export')]">{{ $t("导出") }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <!--        <el-button :disabled="!selectCustomerList.length" @click="setChangeCustomerAir(true)" v-if="$route.path === '/customer/customer'" type="primary" plain  size="mini"  :loading="exportLoading"-->
        <!--                   v-hasPermi="['ecw:customer:transport']" >{{$t('设为空运客户')}}</el-button>-->
      </el-col>
      <el-col :span="1.5">
        <!--        <el-button :disabled="!selectCustomerList.length" @click="setChangeCustomerAir(false)" v-if="$route.path === '/customer/customer'" type="primary" plain  size="mini"  :loading="exportLoading"-->
        <!--                   v-hasPermi="['ecw:customer:transport']">{{$t('设为非空运客户')}}</el-button>-->
      </el-col>
      <el-col :span="1.5">
        <el-button v-hasPermi="['ecw:customer:fcl']" :disabled="!selectCustomerList.length" @click="setFullContainerLoad(true)" v-if="$route.path === '/customer/customer'" type="primary" plain size="mini" :loading="exportLoading">{{ $t("设置海运整柜客户") }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button v-hasPermi="['ecw:customer:fcl-mistake']" :disabled="!selectCustomerList.length" @click="setFullContainerLoad(false)" v-if="$route.path === '/customer/customer'" type="primary" plain size="mini" :loading="exportLoading">{{ $t("设置海运非整柜客户") }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button v-has-permi="[selectAuthorityFn('ecw:customer:create-potential')]" v-if="path === '/customer/customer'" type="primary" plain icon="el-icon-plus" size="mini" @click="handleAddPotential">{{ $t("新增潜在客户") }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleMergeCus" v-has-permi="[selectAuthorityFn('ecw:customer:merge')]" v-if="path === '/customer/customer'">{{ $t("合并客户") }}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table ref="multipleTable" border v-loading="loading" :data="list" @selection-change="handleSelectionChange" id="dataTable" :height="autoHeight">
      <el-table-column type="selection" width="55" fixed></el-table-column>
      <el-table-column :label="$t('客户编号')" align="center" fixed>
        <template v-slot="{ row }">
          <router-link :to="`/customer/query/${row.id}`" class="link-type">
            {{ row.number }}
          </router-link>
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户名称')" align="center" fixed>
        <template slot-scope="{ row }">
          <p style="display: inline-block; white-space: pre-wrap">
            {{ $l(row, "name") }}
          </p>
          <el-tag v-if="row.isInOpenSea" size="mini">{{ $t("公") }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户状态')" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <!--
      <el-table-column :label="$t('客户等级')" align="center">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_LEVEL" :value="scope.row.level" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('信用等级')" :prop="isChinese ? 'creditLevelNameZh' : 'creditLevelNameEn'"></el-table-column>
      -->

      <el-table-column :label="$t('主联系人')" prop="defaultContactName"></el-table-column>
      <el-table-column :label="$t('主联系方式')" prop="defaultContactPhone">
        <template v-slot="{ row }">
          +{{ row.defaultContactPhone }} <br />
          <contacts :id="row.id">
            <el-button type="text">更多</el-button>
          </contacts>
        </template>
      </el-table-column>
      <el-table-column :label="$t('最新发货时间')" width="120">
        <template slot-scope="scope" v-if="scope.row.lastLoadOrderId">
          <router-link :to="`/order/detail?orderId=${scope.row.lastLoadOrderId}`" class="link-type">
            {{ parseTime(scope.row.lastLoadOrderLoadTime) }}
          </router-link>
        </template>
      </el-table-column>
      <el-table-column :label="$t('最新报价单')" width="120">
        <template slot-scope="scope" v-if="scope.row.offerId">
          <router-link :to="`/offer/detail?offerId=${scope.row.offerId}`" class="link-type">
            {{ scope.row.offerNumber }}
          </router-link>
        </template>
      </el-table-column>
      <el-table-column :label="$t('最新跟进时间')" width="120">
        <template slot-scope="scope" v-if="scope.row.followupBackVO">
          {{ parseTime(scope.row.followupBackVO.followTime) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('最新跟进记录')" width="120">
        <template slot-scope="scope" v-if="scope.row.followupBackVO">
          <a href="javascript:void(0)" @click="handleCustomerFollowLink(scope.row.followupBackVO)" class="link-type">{{ scope.row.followupBackVO.number }}</a>
        </template>
      </el-table-column>

      <el-table-column :label="$t('客户类别')" align="center" prop="status">
        <template slot-scope="{ row }">
          {{
            getDictDatas2(DICT_TYPE.CUSTOMER_TYPE, (row.type || "").split(","))
              .map((e) => (isChinese ? e.label : e.labelEn))
              .join(", ")
          }}
          <!--          <dict-tag-->
          <!--            :type="DICT_TYPE.CUSTOMER_TYPE"-->
          <!--            :value="scope.row.type"-->
          <!--          />-->
        </template>
      </el-table-column>
      <el-table-column :label="$t('角色')" align="center" prop="status">
        <template slot-scope="{ row }">
          {{
            getDictDatas2(DICT_TYPE.CUSTOMER_ROLE, (row.roles || "").split(","))
              .map((e) => (isChinese ? e.label : e.labelEn))
              .join(", ")
          }}
          <!--          {{ getCustomerRoles(row.roles) }}-->
          <!--          <dict-tag-->
          <!--            :type="DICT_TYPE.CUSTOMER_ROLE"-->
          <!--            :value="scope.row.roles"-->
          <!--          />-->
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户经理')" align="center" prop="customerServiceName"></el-table-column>
      <el-table-column :label="$t('国籍')" align="center" prop="country" :formatter="countryFormatter"></el-table-column>
      <el-table-column :label="$t('出货渠道')" align="center">
        <template slot-scope="{ row }">
          {{ channel(row.transportType) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户来源')">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_SOURCE" :value="scope.row.source" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('业务国家')">
        <template slot-scope="{ row }">
          {{ getBusiCountryNames(row.busiCountryIds) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('常用提货网点')">
        <template slot-scope="{ row }">
          {{
            getDictDatas2(DICT_TYPE.PICKUP_POINTS, (row.pickupPoints || "").split(","))
              .map((e) => (isChinese ? e.label : e.labelEn))
              .join(", ")
          }}
          <!--          {{ getPickupPointNames(row.pickupPoints) }}-->
        </template>
      </el-table-column>
      <el-table-column :label="$t('年度发货量')" align="center">
        <template slot-scope="{ row }">
          {{ row.weightYearly }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('主营类别')">
        <template slot-scope="{ row }">
          {{ getProductTypeNames(row.productTypes) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('主要竞争对手')" prop="competitorNames"> </el-table-column>
      <el-table-column :label="$t('年度发货次数')" align="center">
        <template slot-scope="{ row }">
          {{ row.numYearly }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('推介人')">
        <template slot-scope="{ row }">
          {{ getPromoterName(row.promoter) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('入公海时间')" align="center" width="160">
        <template v-slot="{ row }">
          {{ parseTime(row.enterOpenSeaTime ? row.enterOpenSeaTime : row.estimateEnterOpenSeaTime) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('入仓确认')" align="center">
        <template slot-scope="scope">
          <el-tag type="success" v-if="scope.row.arrivalConfirm == 1">{{ $t("是") }}</el-tag>
          <el-tag type="info" v-else>{{ $t("否") }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column :label="$t('控货无收货人')" align="center">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.noConsignee" disabled />
        </template>
      </el-table-column>
      <el-table-column :label="$t('默认付款')" align="center">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.defaultPay" disabled />
        </template>
      </el-table-column>
      <el-table-column :label="$t('归属时间')" width="160" align="center">
        <template slot-scope="scope">
          {{ parseTime(scope.row.customerServiceConfirmedTime) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('首次成交时间')" width="160" align="center">
        <template slot-scope="scope">
          {{ parseTime(scope.row.firstDealTime) }}
        </template>
      </el-table-column>
      <el-table-column :label="$t('获取方式')" align="center">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_GET_METHOD" :value="scope.row.getMethod" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('创建人')" prop="createUsername" align="center"> </el-table-column>
      <el-table-column :label="$t('创建时间')" align="center" width="160">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('最后更新时间')" align="center" width="160">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column width="200px" :label="$t('操作')" align="center" fixed="right">
        <template slot-scope="scope">
          <!--          <el-button size="mini" type="text" v-show="'development' === env && scope.row.isInOpenSea"  @click="seasPond(scope.row)"-->
          <!--                     v-hasPermi="['ecw:customer:query']">{{$t('掉入公海池')}}</el-button>-->
          <el-button size="mini" type="text" icon="el-icon-view" @click="handleView(scope.row)" v-hasPermi="[selectAuthorityFn('ecw:customer:index-query')]">{{ $t("查看") }}</el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="[selectAuthorityFn('ecw:customer:update')]">{{ $t("修改") }}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="[selectAuthorityFn('ecw:customer:delete')]">{{ $t("删除") }}</el-button>
          <el-button size="mini" v-has-permi="[selectAuthorityFn('ecw:customer:follow-up')]" type="text" icon="el-icon-collection" @click="followUp(scope.row)">{{ $t("跟进") }}</el-button>
          <el-button size="mini" v-has-permi="[selectAuthorityFn('ecw:customer:customer-complaint')]" type="text" icon="el-icon-user" @click="complaint(scope.row)">{{ $t("客诉") }}</el-button>
          <el-button :disabled="scope.row.isInOpenSea" v-has-permi="[selectAuthorityFn('ecw:customer:postpone')]" size="mini" type="text" icon="el-icon-user" @click="delay(scope.row)">{{ $t("延期") }}</el-button>
          <el-button v-has-permi="['ecw:customer:treat-recovery']" v-if="scope.row.customerService !== null && scope.row.customerServiceAssignedTime !== null && !scope.row.isCustomerServiceConfirmed && !scope.row.isInOpenSea && path === '/customer/customer'" size="mini" type="text" @click="recovery(scope.row)">
            {{ $t("回收客户") }}
          </el-button>
          <el-button
            v-has-permi="['ecw:customer:performanceType']"
            v-if="path === '/customer/customer'"
            size="mini"
            type="text"
            @click="
              dialogVisible = true
              customData = scope.row
              currentisNew = scope.row.isNew
            "
          >
            {{ $t("业绩类型") }}
          </el-button>
          <!--lanbm 2024-05-23 添加报价按钮逻辑控制-->
          <el-button v-has-permi="[selectAuthorityFn('ecw:customer:treat-quoted-price')]" size="mini" type="text" icon="el-icon-user" @click="quote(scope.row)">{{ $t("报价") }}</el-button>
          <el-button v-has-permi="['ecw:customer:setting']" size="mini" type="text" icon="el-icon-user" @click="handleSetting(scope.row)">{{ $t("设置") }}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="90%" append-to-body :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="150px">
        <el-row :gutter="10">
          <el-col :span="12">
            <el-form-item :label="$t('客户名称')" prop="name">
              <el-input v-model="form.name" :placeholder="$t('请输入客户名称')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('国家')" prop="country">
              <el-select v-model="form.country" :placeholder="$t('请选择国家')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.COUNTRY)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('客户等级')" prop="level">
              <el-select v-model="form.level" :placeholder="$t('请选择客户等级')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_LEVEL)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('联系地址')" prop="address">
              <el-input v-model="form.address" :placeholder="$t('请输入联系地址')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('客户类别')" prop="type">
              <el-select v-model="form.type" :placeholder="$t('请选择客户类别')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_TYPE)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="dict.value" />
              </el-select>
            </el-form-item>
          </el-col>
          <!--          <el-col :span="12">-->
          <!--            <el-form-item :label="$t('所属代理')" prop="agentId">-->
          <!--              <el-select v-model="form.agentId" :placeholder="$t('请选择所属代理')">-->
          <!--                <el-option v-for="dict in getDictDatas(DICT_TYPE.COMMON_STATUS)"-->
          <!--                           :key="dict.value" :label="dict.label" :value="parseInt(dict.value)" />-->
          <!--              </el-select>-->
          <!--            </el-form-item>-->
          <!--          </el-col>-->
          <el-col :span="12">
            <el-form-item :label="$t('常用提货网点')" prop="pickupPoint">
              <el-select filterable multiple v-model="form.pickupPoints" :placeholder="$t('请选择提货网点')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.PICKUP_POINTS)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('公司名称')" prop="company">
              <el-input v-model="form.company" :placeholder="$t('请输入公司名称')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('客户生日')" prop="birthday">
              <el-date-picker v-model="form.birthday" type="date" value-format="timestamp" :placeholder="$t('请输入客户生日')"> </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('主营类别')" prop="productTypes">
              <el-row :gutter="10">
                <el-col :span="11">
                  <el-select v-model="form.productTypes" :placeholder="$t('请选择产品类别')">
                    <!--                   <el-option :label="$t('请选择字典生成')" value="" />-->
                  </el-select>
                </el-col>
                <el-col :span="11">
                  <el-select v-model="form.productTypes" :placeholder="$t('请选择主营类别')">
                    <!--                    <el-option :label="$t('请选择字典生成')" value="" />-->
                  </el-select>
                </el-col>
              </el-row>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('客户来源')" prop="source">
              <el-select v-model="form.source" :placeholder="$t('请选择客户来源')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_SOURCE)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('结算方式')" prop="balance">
              <el-select v-model="form.balance" :placeholder="$t('请选择结算方式')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_BALANCE)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('客户经理')" prop="customerService">
              <el-select v-model="form.customerService" :placeholder="$t('请选择客户经理')">
                <el-option v-for="dict in customerServiceList" :key="dict.id" :label="dict.nickname" :value="dict.id" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('图片')" prop="picture">
              <upload v-model="form.picture" :limit="1"></upload>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('客户状态')" prop="status">
              <el-select v-model="form.status" :placeholder="$t('请选择客户状态')">
                <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_STATUS)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('推介人')" prop="promoter">
              <el-input v-model="form.promoter" :placeholder="$t('请输入推介人')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('创建人')" prop="founder">
              <el-input v-model="form.founder" :placeholder="$t('请输入创建人')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('创建时间')" prop="founder">
              <el-date-picker v-model="form.createTime" type="datetime" value-format="timestamp" :placeholder="$t('选择创建时间')"> </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('备注')" prop="remarks">
              <el-input v-model="form.remarks" :placeholder="$t('请输入备注')" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item :label="$t('到仓确认')" prop="arrivalConfirm">
              <el-switch v-model="form.arrivalConfirm" :active-value="0" :inactive-value="1" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item :label="$t('重货标准(CBM)')" prop="weightUnit">
              <el-input v-model="form.weightUnit" :placeholder="$t('请输入重货标准(CBM)')" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item :label="$t('指定线路')" prop="line">
              <el-switch v-model="showLine"></el-switch>
              <el-table v-show="showLine" border :data="form.customerLines" style="width: 500px">
                <el-table-column prop="departureId" :label="$t('始发地')"> </el-table-column>
                <el-table-column prop="objectiveId" :label="$t('目的地')"> </el-table-column>
              </el-table>
            </el-form-item>
          </el-col>
        </el-row>

        <el-card class="box-card">
          <div slot="header" class="clearfix">
            <span>{{ $t("联系人") }}</span>
            <el-button style="float: right" size="small" type="primary" @click="form.customerContacts.push({ department: undefined })">+</el-button>
          </div>
          <el-table :data="form.customerContacts" style="width: 100%">
            <el-table-column prop="department" :label="$t('部门')" width="">
              <template v-slot="{ row, column, $index }">
                <el-input v-model="row.department" :placeholder="$t('请输入部门')" size="mini" />
              </template>
            </el-table-column>
            <el-table-column prop="position" :label="$t('职位')" width="">
              <template v-slot="{ row }">
                <el-input v-model="row.position" :placeholder="$t('请输入职位')" size="mini" />
              </template>
            </el-table-column>
            <el-table-column prop="name" :label="$t('联系人')">
              <template v-slot:header>{{ $t("联系人") }}<span style="color: #ff0000">*</span> </template>
              <template v-slot="{ row }">
                <el-input v-model="row.name" :placeholder="$t('请输入联系人')" size="mini" />
              </template>
            </el-table-column>
            <el-table-column prop="areaCode" :label="$t('区号')">
              <template v-slot:header>{{ $t("区号") }}<span style="color: #ff0000">*</span> </template>
              <template v-slot="{ row }">
                <el-select v-model="row.areaCode" :placeholder="$t('请选择区号')">
                  <el-option v-for="dict in getDictDatas(DICT_TYPE.AREA_CODE)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
                </el-select>
              </template>
            </el-table-column>
            <el-table-column prop="phoneNew" :label="$t('联系方式')">
              <template v-slot:header>{{ $t("联系方式") }}<span style="color: #ff0000">*</span> </template>
              <template v-slot="{ row }">
                <el-input v-model="row.phoneNew" :placeholder="$t('请输入联系方式')" size="mini" />
              </template>
            </el-table-column>
            <el-table-column prop="" :label="$t('关联账号')"> </el-table-column>
            <el-table-column prop="social" :label="$t('社交软件')">
              <template v-slot="{ row }">
                <el-select v-model="row.social" :placeholder="$t('请选择社交软件')">
                  <el-option v-for="dict in getDictDatas(DICT_TYPE.SOCIAL)" :key="dict.value" :label="isChinese ? dict.label : dict.labelEn" :value="parseInt(dict.value)" />
                </el-select>
              </template>
            </el-table-column>
            <el-table-column prop="socialNumber" :label="$t('社交软件号码')">
              <template v-slot="{ row }">
                <el-input v-model="row.socialNumber" :placeholder="$t('请输入社交软件号码')" size="mini" />
              </template>
            </el-table-column>
            <el-table-column prop="email" :label="$t('邮箱')">
              <template v-slot="{ row }">
                <el-input v-model="row.email" :placeholder="$t('请输入邮箱')" size="mini" />
              </template>
            </el-table-column>
            <el-table-column prop="isDefault" :label="$t('设为默认')">
              <template v-slot="{ row }">
                <el-select v-model="row.isDefault" :placeholder="$t('设为默认')">
                  <el-option v-for="dict in getDictDatas(DICT_TYPE.IS_DEFAULT)" :key="dict.value" :label="dict.label" :value="parseInt(dict.isDefault)" />
                </el-select>
              </template>
            </el-table-column>
            <el-table-column prop="name" :label="$t('操作')">
              <template v-slot="{ row, column, $index }">
                <el-button type="danger" @click="form.customerContacts.splice($index, 1)">{{ $t("删除") }}</el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-card>

        <el-row :gutter="10" style="margin-top: 15px">
          <el-col :span="12">
            <el-form-item :label="$t('发票抬头')" prop="invoiceTitle">
              <el-input v-model="form.invoiceTitle" :placeholder="$t('请输入发票抬头')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('纳税人识别号')" prop="licenseNumber">
              <el-input v-model="form.licenseNumber" :placeholder="$t('请输入纳税人识别号')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('开户行')" prop="bank">
              <el-input v-model="form.bank" :placeholder="$t('请输入开户行')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('账户')" prop="bankNumber">
              <el-input v-model="form.bankNumber" :placeholder="$t('请输入账户')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('项目')" prop="project">
              <el-input v-model="form.project" :placeholder="$t('请输入项目')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('开票地址')" prop="billingAddress">
              <el-input v-model="form.billingAddress" :placeholder="$t('请输入开票地址')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('开票电话')" prop="billingTell">
              <el-input v-model="form.billingTell" :placeholder="$t('请输入开票电话')" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('税率')" prop="taxRate">
              <el-input v-model="form.taxRate" :placeholder="$t('请输入税率')" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t("确 定") }}</el-button>
        <el-button @click="cancel">{{ $t("取 消") }}</el-button>
      </div>
    </el-dialog>
    <customer-follow-list :customer-id="customerId" :id="customerId" :customer-service="customerService" :customer-number="customerNumber" @refresh="handleQuery" ref="CustomerFollowList" v-if="customerFollowVisible"></customer-follow-list>
    <customer-follow ref="customerFollow" @refresh="handleQuery" @close="customerFollowVisible = false" v-if="customerFollowVisible" />
    <customer-complaints :customerName="selectedCustomerName" :customerNumber="selectedCustomerNumber" :customer-id="customerId" ref="customerComplaints"></customer-complaints>
    <transfer-customer :show.sync="transferShow" :customer-ids.sync="selectCustomerList"></transfer-customer>
    <add-potential-custom ref="potentialCustom" @change="getList"></add-potential-custom>
    <customer-setting ref="customerSetting" @refresh="getList"></customer-setting>
    <customer-merge ref="customerMerge" @refresh="getList" :countryList="countryList" :getNodeLists="getNodeLists" :productTypeList="getNodeLists" :customerSelectFn="customerSelectFn" v-if="customerMergeVisible"></customer-merge>
    <!--业绩类型   -->
    <el-dialog title="业绩类型" :visible.sync="dialogVisible" width="30%">
      <div>
        <el-form>
          <el-form-item label="客户编号">{{ customData.number }}</el-form-item>
          <el-form-item label="客户名称">{{ customData.name }}</el-form-item>
          <el-form-item label="业绩类型">
            <el-radio-group v-model="currentisNew">
              <el-radio :label="true">{{ $t("新客户") }}</el-radio>
              <el-radio :label="false">{{ $t("老客户") }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button :disabled="customData.isNew === currentisNew" type="primary" @click="modifyCustomer">修改</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { createCustomer, updateCustomer, deleteCustomer, getCustomer, getCustomerPage, exportCustomerExcel, testEnterToOpenSea, getCustomerDeptPage, changeCustomerAir, getPotential, setChangeCustomerFcl, potentialExportExcel, deptExportExcel, recycleUnconfirmedCustomer, updatecustomerToOld, competitorListAll } from "@/api/ecw/customer"
import { getDictDatas, DICT_TYPE, getDictDatas2 } from "@/utils/dict"
import { CommonStatusEnum } from "@/utils/constants"
import { uploadFile } from "@/api/infra/file"
import upload from "@/components/ImageUpload"
import { getNodeList } from "@/api/ecw/node"
import CustomerFollowList from "./components/customerFollow"
import customerComplaints from "@/components/customerComplaints"
import { listServiceUser, getUserProfile, listAllSimpl } from "@/api/system/user"
import { getCountryListAll } from "@/api/ecw/country"
import { getCreditPage } from "@/api/customer/credit"
import { customerExportExcel, changeCustomerDefaultPay, changeCustomerNoConsignee, changeCustomerDefaultBilling } from "@/api/ecw/customer"
import transferCustomer from "@/views/ecw/customer/transferCustomer"
import Template from "@/views/cms/template/index.vue"
import AddPotentialCustom from "@/views/ecw/customer/addPotentialCustom.vue"
import Contacts from "@/views/ecw/customer/components/contacts.vue"
import CustomerSetting from "./components/customerSetting.vue"
import CustomerMerge from "./components/customerMerge.vue"
import AreaCodeSelector from "@/components/AreaCodeSelector/index.vue"
import { getCustomerSelect } from "@/api/ecw/customer"
import { getProductTypeList } from "@/api/ecw/productType"
import { getProductList } from "@/api/ecw/product"
import { listMySimpleDepts } from "@/api/system/dept"
import UserSelector from "@/components/UserSelector/index.vue"
import CustomerFollow from "@/views/ecw/customer/components/customerFollow.vue"
import ProductSelector from "@/components/ProductSelector/index.vue"
import CompetitorSelector from "@/components/CompetitorSelector/index.vue"
export default {
  name: "EcwCustomerIndex",
  components: {
    ProductSelector,
    CompetitorSelector,
    Contacts,
    AddPotentialCustom,
    Template,
    upload,
    CustomerFollowList,
    customerComplaints,
    transferCustomer,
    AreaCodeSelector,
    CustomerSetting,
    CustomerMerge,
    CustomerFollow
  },
  data() {
    return {
      env: process.env.NODE_ENV,
      getDictDatas,
      getDictDatas2,
      DICT_TYPE,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 客户列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10
        /*number: null,
        name: null,
        level: null,
        source: null,
        customerService: null,
        status: null,
        department: null,
        creditLevel: null,
        country: null,
        resourceType: null,
        memberCode: null,
        memberName: null,
        memberMobile: null,
        memberAreaCode: null,*/
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          {
            required: true,
            message: this.$t("客户名称不能为空"),
            trigger: "blur"
          }
        ],
        country: [{ required: true, message: this.$t("国家不能为空"), trigger: "blur" }],
        level: [
          {
            required: true,
            message: this.$t("客户等级不能为空"),
            trigger: "blur"
          }
        ],
        type: [
          {
            required: true,
            message: this.$t("客户类别不能为空"),
            trigger: "blur"
          }
        ],
        // createTime: [{ required: true, message: this.$t("创建时间不能为空"), trigger: "blur" }],
        source: [
          {
            required: true,
            message: this.$t("客户来源不能为空"),
            trigger: "blur"
          }
        ],
        customerService: [
          {
            required: true,
            message: this.$t("客户经理不能为空"),
            trigger: "blur"
          }
        ],
        status: [
          {
            required: true,
            message: this.$t("客户状态不能为空"),
            trigger: "blur"
          }
        ],
        founder: [
          {
            required: true,
            message: this.$t("创建人不能为空"),
            trigger: "blur"
          }
        ]
      },
      // 网点
      nodeList: [],
      showLine: false,
      customerId: undefined,
      selectedCustomerName: "",
      selectedCustomerNumber: "",
      customerServiceList: [],
      countryList: [],
      creditList: [],
      selectCustomerList: [],
      transferShow: false,
      dialogVisible: false,
      customData: {},
      currentisNew: false,
      userId: undefined, //lanbm 2024-05-23 add
      customerService: undefined,
      customerNumber: undefined,
      customerFollowVisible: false,
      customerMergeVisible: false,
      enterOpenSeaTime: [],
      customerServiceConfirmedTime: [],
      firstDealTime: [],
      createTime: [],
      autoClearedCreateTime: false,
      clearedCreateNum: 0,
      customerSelect: [],
      recommended: [],
      getNodeLists: [],
      allSimplList: [],
      weightYearly: {
        key: "eqNumberKey",
        value: ""
      },
      numYearly: {
        key: "eqNumberKey",
        value: ""
      },
      productTypeList: [],
      productList: [],
      competitorList: [],
      deptList: [],
      autoHeight: 500
    }
  },
  computed: {
    isMobile() {
      const userAgent = navigator.userAgent || navigator.vendor || window.opera;
      // 匹配常见的移动设备标识
      const mobileIdentifiers = ['Android', 'webOS', 'iPhone', 'iPad', 'iPod', 'BlackBerry', 'Windows Phone'];
      return mobileIdentifiers.some(identifier => userAgent.includes(identifier));
    },
    path() {
      return this.$route.path
    },
    channel() {
      return (val) => {
        return !!val
          ? this.getDictDatas(this.DICT_TYPE.ECW_CUSTOMER_TRANSPORT_TYPE)
              .filter((i) => (val.split(",") || []).includes(i.value))
              .map((i) => (this.isChinese ? i.label : i.labelEn))
              .join("，")
          : ""
      }
    },
    isChinese() {
      return this.$i18n.locale === "zh_CN"
    },
    authorityFn() {
      let i = ""
      switch (this.$route.path) {
        case "/customer/department-customers":
          i = "dep-"
          break
        case "/customer/potential":
          i = "pot-"
          break
      }
      return i
    },
    selectAuthorityFn() {
      return (val) => {
        let t = val.split(":")
        t[t.length - 1] = this.authorityFn + t[t.length - 1]
        // console.log(t.join(":"))
        return t.join(":")
      }
    },
    customerSelectFn() {
      if (this.recommended.length > 0) {
        let i = this.customerSelect.find((item) => item.id === this.recommended[0].id)
        if (!i) {
          this.customerSelect.push(this.recommended[0])
        }
        return this.customerSelect
      } else {
        return this.customerSelect
      }
    },
    combinedQueryParams() {
      let queryParams = {}
      if (this.enterOpenSeaTime && this.enterOpenSeaTime.length == 2) {
        queryParams.beginEnterOpenSeaTime = this.enterOpenSeaTime[0]
        queryParams.endEnterOpenSeaTime = this.enterOpenSeaTime[1]
      }
      if (this.customerServiceConfirmedTime && this.customerServiceConfirmedTime.length == 2) {
        queryParams.beginCustomerServiceConfirmedTime = this.customerServiceConfirmedTime[0]
        queryParams.endCustomerServiceConfirmedTime = this.customerServiceConfirmedTime[1]
      }
      if (this.firstDealTime && this.firstDealTime.length == 2) {
        queryParams.beginFirstDealTime = this.firstDealTime[0]
        queryParams.endFirstDealTime = this.firstDealTime[1]
      }
      if (this.createTime && this.createTime.length == 2) {
        queryParams.beginCreateTime = this.createTime[0]
        queryParams.endCreateTime = this.createTime[1]
      }
      if (this.weightYearly.value) {
        let key = "eqWeightYearly"
        if (this.weightYearly.key == "leNumberKey") {
          key = "leWeightYearly"
        } else if (this.weightYearly.key == "geNumberKey") {
          key = "geWeightYearly"
        }
        queryParams[key] = this.weightYearly.value
      }
      if (this.numYearly.value) {
        let key = "eqNumYearly"
        if (this.numYearly.key == "leNumberKey") {
          key = "leNumYearly"
        } else if (this.numYearly.key == "geNumberKey") {
          key = "geNumYearly"
        }
        queryParams[key] = this.numYearly.value
      }

      return queryParams
    }
  },
  watch: {
    queryParams: {
      handler() {
        this.clearedCreateNum++ // 记录用户改动搜索框次数
        console.log('clearedCreateNum:' + this.clearedCreateNum)
        // 当页面尚未自动清空过创建时间，并且创建时间不为空时
        // 页面加载完成后，这里的值是5，如果查询条件功能做了修改也可能要改动
        if (this.clearedCreateNum == 5 && this.createTime && this.createTime.length > 0) {
          this.createTime = [] // 清空创建时间条件数据
          this.autoClearedCreateTime = true  // 记录已经清空过
        }
      },
      deep: true, // 深度监听
    },
    showSearch() {
      this.$nextTick(() => {
        this.getHeight()
      })
    },
    selectCustomerList(val) {
      if (val.length === 0) {
        this.getList()
        this.$refs.multipleTable.clearSelection()
      }
    }
  },
  created() {
    console.log("created")

    getCreditPage({ page: 1, rows: 999 }).then((r) => {
      this.creditList = r.data.list
    })
    // 获取当前时间的年份开始时间与结束时间值,并赋值给创建时间,再查询当年创建的客户
    this.getCurrentYearList()
    // this.getList()
    listServiceUser().then((r) => {
      this.customerServiceList = r.data
    })
    getCountryListAll().then((r) => {
      this.countryList = r.data
    })
    //获取用户id信息 lanbm 2024-05-23 add
    getUserProfile().then((res) => {
      this.userId = res.data.id
    })
    this.getCustomerSelect()
    getNodeList().then((r) => {
      this.getNodeLists = r.data
    })
    listAllSimpl().then((r) => {
      this.allSimplList = r.data
    })
    getProductTypeList().then((r) => {
      this.productTypeList = r.data
    })
    competitorListAll().then((r) => {
      this.competitorList = r.data
    })
    listMySimpleDepts().then((response) => {
      this.deptList = response.data
    })
  },
  updated() {
    this.$nextTick(() => {
      this.$refs.multipleTable.doLayout()
    })
  },
  activated() {
    console.log("activated")

    this.getList()
  },
  methods: {
    onCompetitorChange(row, competitor) {
      // row.goodsType = product ? product.typeId : null
      row.id = !competitor
        ? []
        : competitor.id
            .split(",")
            .filter((item) => item !== "")
            .map((item) => +item)
      if (competitor) {
        this.$set(this.names, competitor.id, {
          name: competitor.name
        })
      }
    },
    getCurrentYearList(){
      const today =  new Date();
      const targetday_milliseconds = today.getTime();
      today.setTime(targetday_milliseconds); //注意，这行是关键代码
      const tYear = today.getFullYear();
      console.log("年份：", tYear)
      if (tYear){
        this.createTime = [(tYear + "-01-01 00:00:00"),(tYear + "-12-31 23:59:59")]
      }
      this.getList()
    },
    //合并客户
    handleMergeCus() {
      this.customerMergeVisible = true
      this.$nextTick((_) => {
        this.$refs["customerMerge"].init()
        this.$refs["customerMerge"].dialogVisible = true
      })
    },
    handleCustomerFollowLink(row) {
      this.customerFollowVisible = true
      this.$nextTick((_) => {
        this.$refs["customerFollow"].handleView(row)
      })
    },
    recovery(row) {
      this.$confirm(this.$t("是否要回收当前{name}", row), "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          recycleUnconfirmedCustomer({ customerId: row.id }).then((r) => {
            this.$message.success(this.$t("回收成功。"))
            this.getList()
          })
        })
        .catch(() => {
          this.$message.info(this.$t("已取消"))
        })
    },
    // 设置整柜
    setFullContainerLoad(isFcl) {
      setChangeCustomerFcl({
        customerIdList: this.selectCustomerList,
        isFcl
      }).then((r) => {
        if (r.code === 0) {
          this.$message.success(isFcl ? "设置客户为海运整柜成功！" : "设置客户为非海运整柜成功！")
          this.selectCustomerList = []
          this.getList()
        }
      })
    },
    // 设置空运客户
    setChangeCustomerAir(isAir) {
      changeCustomerAir({
        customerIdList: this.selectCustomerList,
        isAir
      }).then((r) => {
        console.log(r)
        if (r.code === 0) {
          this.$message.success(isAir ? "设为空运客户成功！" : "设为非空运客户成功！")
          this.selectCustomerList = []
          this.getList()
        }
      })
    },
    /** 取消按钮 */
    cancel() {
      this.open = false
      this.reset()
    },
    complaint(row) {
      this.customerId = row.id
      this.selectedCustomerName = row.name
      this.selectedCustomerNumber = row.number
      this.$nextTick(() => {
        this.$refs.customerComplaints.handleAdd()
      })
    },
    // 去掉客户名称的首尾空格
    trimCustomerName() {
      this.queryParams.name = this.queryParams.name.trim()
    },
    countryFormatter(row, column, cellValue) {
      const country = this.countryList.find((e) => e.id === cellValue)
      return this.isChinese ? country?.nameZh : country?.nameEn
    },
    delay(row) {
      this.$router.push({ path: "/customer/delay", query: { id: row.id } })
    },
    followUp(row) {
      this.customerId = row.id
      this.customerService = row.customerService
      this.customerNumber = row.number
      this.customerFollowVisible = true
      this.$nextTick((_) => {
        // this.$refs.CustomerFollowList.customerFollow.dialogVisible = true;
        // this.$refs["CustomerFollowList"].init()
        this.$refs["CustomerFollowList"].handleAdd()
      })
    },
    //报价
    quote(row) {
      //lanbm 2024-05-23 添加报价是判断客户所属客户经理，不是就不能报价
      //jayden 2024-12-12 添加报价是判断客户所属客户经理，不是就不能报价（删除限制）
      // if (row.customerService != this.userId) {
      //   this.$message.error(this.$t("此客户属于其他客户经理名下的客户。"))
      //   return
      // }
      //this.$router.push({path:'/offer/create',query:{id:row.id}})
      this.$router.push({ path: "/offer/create", query: { customerId: row.id, customerType: row.type, type: 1 } }).then({
        //this.$refs.push({path:'/customer-contacts/select',query:{pageNo:1,pageSize:10,searchKey:row.defaultContactPhone}})
      })
    },
    hasNonEmptyQueryCondition() {
      // 用于判断搜索字段内容是否做了修改
      return Object.keys(this.queryParams).some(key => {
        // 如果不需要判断某个字段，可在此处进行排除
        if(key === 'pageNo') return false;
        if(key === 'pageSize') return false;
        if(key === 'searchKey') return false;
        const value = this.queryParams[key]
        if (typeof value === 'string') {
          return value.trim() !== ''
        } else if (Array.isArray(value)) {
          return value.length > 0
        } else if (typeof value === 'object' && value !== null) {
          return Object.keys(value).length > 0
        }
        return value !== null && value !== undefined
      })
    },
    /** 查询列表 */
    getList() {
      this.loading = true
      // 处理查询参数
      let params = { ...this.queryParams, ...this.combinedQueryParams }

      // 执行查询
      switch (this.$route.path) {
        case "/customer/customer":
          getCustomerPage(params).then(this.setData)
          break
        case "/customer/department-customers":
          getCustomerDeptPage(params).then(this.setData)
          break
        case "/customer/potential":
          getPotential(params).then(this.setData)
          break
      }
    },
    remoteMethod(val) {
      this.getCustomerSelect(val)
    },
    getCustomerSelect(val = "") {
      getCustomerSelect({ pageNo: 1, pageSize: 30, searchKey: val }).then((res) => {
        this.customerSelect = res.data.list
      })
    },
    handleSelectProductType(val) {
      if (val && val.length >= 1) {
        this.queryParams.productIds = []
        getProductList({ typeIds: val }).then((r) => {
          this.productList = r.data
        })
      } else {
        this.queryParams.productIds = []
        this.productList = []
      }
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push("/customer/add-edit/0")
      // this.reset();
      // this.open = true;
      // this.title = this.$t("添加客户");
    },
    // 新增潜在客户
    handleAddPotential() {
      this.$refs.potentialCustom.dialogTableVisible = true
      this.$nextTick((_) => {
        // 每次点击弹出窗口都获取商品信息
        this.$refs.potentialCustom.form.products = []
        this.$refs.potentialCustom.form.products.push({ typeId: undefined, productIds: [], productList: [] })
        this.$refs.potentialCustom.getProductListFn(0,[undefined]);
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id
      const name = row.name
      const number = row.number
      this.$modal
        .confirm(this.$t('是否确认删除客户编号为"') + number + this.$t('"的数据项?'))
        .then(function () {
          return deleteCustomer(id)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess(this.$t("删除成功"))
        })
        .catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      let func = null
      let title = ""
      switch (this.$route.path) {
        case "/customer/customer":
          func = customerExportExcel
          title = "是否确认导出所有客户数据项?"
          break
        case "/customer/department-customers":
          func = deptExportExcel
          title = "是否确认导出部门客户数据项?"
          break
        case "/customer/potential":
          func = potentialExportExcel
          title = "是否确认导出潜在客户数据项?"
          break
      }

      // // 执行导出
      this.$modal
        .confirm(this.$t(title))
        .then(() => {
          func().then((r) => {
            this.$message.success(this.$t("已加入导出队列，请稍后在下载日志中下载"))
          })
        })
        .catch(() => {})
    },
    /** 搜索按钮操作 */
    handleQuery() {
      // 第一次通过查询选择框触发会清空创建时间
      if (
        !this.autoClearedCreateTime &&
        this.hasNonEmptyQueryCondition() &&
        (this.createTime && this.createTime.length > 0)
      ) {
        this.createTime = []             // 自动清空创建时间数据
        this.autoClearedCreateTime = true  // 记录已经清空过
      }
      this.queryParams.pageNo = 1
      this.getList()
    },
    handleSelectionChange(val) {
      this.selectCustomerList = val.map((i) => i.id)
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      console.log(row.id)
      switch (this.$route.path) {
        case "/customer/customer":
          this.$router.push("/customer/add-edit/" + row.id)
          break
        case "/customer/department-customers":
          this.$router.push("/customer/add-edit/" + row.id)
          break
        case "/customer/potential":
          this.$router.push("/customer/add-edit/" + row.id + "?potential=true")
          break
        default:
          this.$router.push("/customer/add-edit/" + row.id)
          break
      }
      // this.reset();
      // const id = row.id;
      // getCustomer(id).then(response => {
      //   this.form = { ...this.form, ...response.data };
      //   this.open = true;
      //   this.title = this.$t("修改客户");
      // });
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push("/customer/query/" + row.id)
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        number: undefined,
        name: undefined,
        level: undefined,
        country: undefined,
        type: undefined,
        agentId: undefined,
        company: undefined,
        address: undefined,
        productTypes: undefined,
        productIds: undefined,
        pickupPoint: undefined,
        memberId: undefined,
        birthday: undefined,
        balance: undefined,
        source: undefined,
        picture: undefined,
        customerService: undefined,
        customerContacts: [],
        customerLines: [],
        promoter: undefined,
        status: undefined,
        founder: undefined,
        department: undefined,
        invoiceTitle: undefined,
        licenseNumber: undefined,
        bank: undefined,
        bankNumber: undefined,
        project: undefined,
        billingAddress: undefined,
        billingTell: undefined,
        taxRate: undefined,
        remarks: undefined,
        arrivalConfirm: undefined,
        weightUnit: undefined
      }
      this.resetForm("form")
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.enterOpenSeaTime = []
      this.customerServiceConfirmedTime = []
      this.firstDealTime = []
      this.createTime = []
      this.resetForm("queryForm")
      this.queryParams = {
        pageNo: 1,
        pageSize: 10
      }
      this.weightYearly.value = ""
      this.numYearly.value = ""
      this.handleQuery()
    },
    /** 调入公海池测试用 */
    seasPond(row) {
      testEnterToOpenSea(row.id).then((r) => {
        if (r.code === 0) {
          this.$t("调入公海池成功！")
          this.getList()
        }
      })
    },
    setData(response) {
      // console.log(response, "response")
      this.list = response.data.list
      this.total = response.data.total
      this.loading = false

      this.$nextTick(() => {
        this.getHeight()
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (!valid) {
          // return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCustomer(this.form).then((response) => {
            this.$modal.msgSuccess(this.$t("修改成功"))
            this.open = false
            this.getList()
          })
          return
        }
        // 添加的提交
        createCustomer(this.form).then((response) => {
          this.$modal.msgSuccess(this.$t("新增成功"))
          this.open = false
          this.getList()
        })
      })
    },
    // 修改客户类型
    modifyCustomer() {
      this.$confirm(this.$t("修改业绩类型后，将会影响客户新订单业绩计算，请问确定吗？"), this.$t("提示"), {
        confirmButtonText: this.$t("确定"),
        cancelButtonText: this.$t("取消"),
        type: "warning"
      })
        .then(() => {
          updatecustomerToOld({
            customerId: this.customData.id,
            isNew: this.currentisNew
          }).then((r) => {
            this.$message.success(this.$t("修改成功"))
            this.dialogVisible = false
            this.getList()
          })
        })
        .catch(() => {})
    },
    setDefaultPay() {
      changeCustomerDefaultPay({
        customerIdList: this.selectCustomerList,
        defaultPay: true
      }).then((_) => {
        this.$message.success(this.$t("操作成功"))
        this.getList()
      })
    },
    setNoConsignee() {
      changeCustomerNoConsignee({
        customerIdList: this.selectCustomerList,
        noConsigee: true
      }).then((_) => {
        this.$message.success(this.$t("操作成功"))
        this.getList()
      })
    },
    setDefaultBilling() {
      changeCustomerDefaultBilling({
        customerIdList: this.selectCustomerList,
        defaultBilling: true
      }).then((_) => {
        this.$message.success(this.$t("操作成功"))
        this.getList()
      })
    },
    handleSetting(row) {
      this.$refs["customerSetting"].dialogVisible = true
      this.$nextTick((_) => {
        this.$refs["customerSetting"].init(row.id)
      })
    },
    getBusiCountryNames(ids) {
      if (ids) {
        const idsArr = ids.split(",")
        const strArr = []
        this.countryList.forEach((item) => {
          if (idsArr.includes(item.id.toString())) {
            strArr.push(this.isChinese ? item.nameZh : item.nameEn)
          }
        })
        return strArr.length > 0 ? strArr.join(",") : null
      } else {
        return null
      }
    },
    getPickupPointNames(ids) {
      if (ids) {
        const idsArr = ids.split(",")
        const strArr = []
        this.getNodeLists.forEach((item) => {
          if (idsArr.includes(item.id.toString())) {
            strArr.push(this.isChinese ? item.titleZh : item.titleEn)
          }
        })
        return strArr.length > 0 ? strArr.join(",") : null
      } else {
        return null
      }
    },
    getCustomerRoles(ids) {
      if (ids) {
        const idsArr = ids.split(",")
        const strArr = []
        DICT_TYPE.CUSTOMER_ROLE.forEach((item) => {
          if (idsArr.includes(item.value.toString())) {
            strArr.push(this.isChinese ? item.label : item.labelEn)
          }
        })
        return strArr.length > 0 ? strArr.join(",") : null
      } else {
        return null
      }
    },
    getProductTypeNames(ids) {
      if (ids) {
        const idsArr = ids.toString().split(",")
        const strArr = []
        this.productTypeList.forEach((item) => {
          if (idsArr.includes(item.id.toString())) {
            strArr.push(this.isChinese ? item.titleZh : item.titleEn)
          }
        })
        return strArr.length > 0 ? strArr.join(",") : null
      } else {
        return null
      }
    },
    getPromoterName(id) {
      if (id) {
        let strName = ""
        for (const item of this.customerSelectFn) {
          if (item.id == id) {
            strName = item.name
            break
          }
        }
        return strName
      } else {
        return null
      }
    },
    //表格高度自适应
    getHeight() {
      if(!this.isMobile) {
        this.$refs.multipleTable.doLayout()
        let getHeightFromBottom = (element, variableHeight) => {
          const elementRect = element.getBoundingClientRect().top;
          const windowHeight = document.documentElement.clientHeight;
          const elementHeightFromBottom = windowHeight - elementRect;
          const result = elementHeightFromBottom - variableHeight;
          return result;
        }
        const element = document.getElementById('dataTable');
        const variableHeight = 70; // 给定的变量高度 一般留于分页器高度
        this.autoHeight =getHeightFromBottom(element, variableHeight);
      }
    },
  }
}
</script>
